/*
Plugin Name: Captcha Free Anti Spam for Contact Form 7 (Simple No-Bot)
Plugin URI: http://www.lilaeamedia.com/simple-no-bot/
Description: Simple, lightweight, no captcha, no configuration. Just works.
Version: 2.1.5
Author: Lilaea Media
License: GPLv2
(c) 2019 J Fleming Lilaea Media LLC
*/
;(function($){
    'use strict';
    
    /**
     * Bind form inputs to mouse/keyboard events
     */
    function init(){
        $( '.wpcf7-form input,.wpcf7-form textarea,.wpcf7-form select' ).on( 'mousedown touchstart', mousedown );
        $( '.wpcf7-form input,.wpcf7-form textarea' ).on( 'keypress', keydown ); //( 'keydown', keydown );
        $( '.wpcf7-form input,.wpcf7-form textarea,.wpcf7-form select' ).on( 'focus', focus );
        if ( window.snbvars.disableSubmit ){
            $( '.wpcf7-form input[type="submit"]' ).prop( 'disabled', true );
            $( '.snb-form input[type="submit"]' ).prop( 'disabled', true );
        }
        $( document ).on( 'wpcf7submit', function(){
            getToken();
            startTime = 0;
            endTime = 0;
            timeSet = 0;
        } );
        // unbind cf7's submit handler so we can inject our own
        $( 'div.wpcf7 > form' ).off( 'submit' ).on( 'submit', setTime ); //'wpcf7beforesubmit', setTime );
        // v.2.0 - listeners for any form
        $( '.snb-form input,.snb-form textarea,.snb-form select' ).on( 'mousedown touchstart', mousedown );
        $( '.snb-form input,.snb-form textarea' ).on( 'keypress', keydown ); //( 'keydown', keydown );
        $( '.snb-form input,.snb-form textarea,.snb-form select' ).on( 'focus', focus );
    }
    
    function setStart(){
        if ( !startTime ){
            // console.log( 'setting start time' );
            startTime = Date.now();
        }
    }
    function getEvent( e, code ){
        var id = e.currentTarget.name ? e.currentTarget.name : ( e.currentTarget.id ? e.currentTarget.id : 'unnamed ' + e.currentTarget.type ),
            eStr = code + ',' + id + ',';
        eventCount++;
        return eStr;
    }
    /**
     * Click listener
     */
    function mousedown( e ){
        setStart();
        if ( !interacted ){
            //console.log( 'mousedown detected ' + e.pageX + ' ' + e.pageY );
            eventstr += getEvent( e, 'm' );
            test();
        }
    }
    
    /**
     * Focus listener
     * We need to test focus event for accessibility
     */
    
    function focus( e ){
        setStart();
        if ( !interacted ){
            // console.log( 'focus detected ' );
            eventstr += getEvent( e, 'f' );
            test();
        }
    }
    
    /**
     * Keystroke listener
     */
    
    function keydown( e ){
        setStart();
        var code = e.which.toString() + ','; //e.keyCode.toString() + ',';
        if ( !interacted ){
            // console.log( 'keydown detected ' + e.which );
            eventstr += getEvent( e, 'k' ) + code;
            test();
        }
    }
    
    /**
     * Check if input event string is long enough to hash
     */
    function test(){
        // console.log( 'testing', eventstr );
        if ( !interacted && eventCount >= window.snbvars.minEvents ){
            interacted++;
            getToken();
        }
    }
    
    function setTime( e ){
        e.preventDefault();

        //console.log( 'setTime' )
        
        if ( !timeSet ){
            endTime = Date.now();
            // console.log( 'start: ' + startTime + ' end: ' + endTime + ' time diff: ' + ( endTime - startTime ) );
            var times = ':' + startTime + ':' + endTime;
            $( '.wpcf7-form input[name="snb-token"]' ).each( function( ndx, el ){
                el.value += times;
                timeSet = 1;
            });
        }
		wpcf7.submit( e.target );
    }

    /**
     * Simple, stable, lightweight string hashing function
     * http://www.webtoolkit.info/
     */
    function generateSha1( r ){function o(r,o){var e=r<<o|r>>>32-o;return e}function e(r){var o,e,a="";for(o=7;o>=0;o--)e=r>>>4*o&15,a+=e.toString(16);return a}function a(r){r=r.replace(/\r\n/g,"\n");for(var o="",e=0;e<r.length;e++){var a=r.charCodeAt(e);128>a?o+=String.fromCharCode(a):a>127&&2048>a?(o+=String.fromCharCode(a>>6|192),o+=String.fromCharCode(63&a|128)):(o+=String.fromCharCode(a>>12|224),o+=String.fromCharCode(a>>6&63|128),o+=String.fromCharCode(63&a|128))}return o}var t,h,n,C,c,f,d,A,u,g=new Array(80),i=1732584193,s=4023233417,S=2562383102,v=271733878,m=3285377520;r=a(r);var p=r.length,l=new Array;for(h=0;p-3>h;h+=4)n=r.charCodeAt(h)<<24|r.charCodeAt(h+1)<<16|r.charCodeAt(h+2)<<8|r.charCodeAt(h+3),l.push(n);switch(p%4){case 0:h=2147483648;break;case 1:h=r.charCodeAt(p-1)<<24|8388608;break;case 2:h=r.charCodeAt(p-2)<<24|r.charCodeAt(p-1)<<16|32768;break;case 3:h=r.charCodeAt(p-3)<<24|r.charCodeAt(p-2)<<16|r.charCodeAt(p-1)<<8|128}for(l.push(h);l.length%16!=14;)l.push(0);for(l.push(p>>>29),l.push(p<<3&4294967295),t=0;t<l.length;t+=16){for(h=0;16>h;h++)g[h]=l[t+h];for(h=16;79>=h;h++)g[h]=o(g[h-3]^g[h-8]^g[h-14]^g[h-16],1);for(C=i,c=s,f=S,d=v,A=m,h=0;19>=h;h++)u=o(C,5)+(c&f|~c&d)+A+g[h]+1518500249&4294967295,A=d,d=f,f=o(c,30),c=C,C=u;for(h=20;39>=h;h++)u=o(C,5)+(c^f^d)+A+g[h]+1859775393&4294967295,A=d,d=f,f=o(c,30),c=C,C=u;for(h=40;59>=h;h++)u=o(C,5)+(c&f|c&d|f&d)+A+g[h]+2400959708&4294967295,A=d,d=f,f=o(c,30),c=C,C=u;for(h=60;79>=h;h++)u=o(C,5)+(c^f^d)+A+g[h]+3395469782&4294967295,A=d,d=f,f=o(c,30),c=C,C=u;i=i+C&4294967295,s=s+c&4294967295,S=S+f&4294967295,v=v+d&4294967295,m=m+A&4294967295}var u=e(i)+e(s)+e(S)+e(v)+e(m);return u.toLowerCase()}
    
    /**
     * Pass input event string over XHR and retrieve unique token from server.
     * Inject new input into any/all contact forms to pass back as verification.
     * Input contains unique token and hashed input event string.
     * Only do this once until form comes back as OK.
     */
    function getToken(){
        if ( pending ) {
            return;
        }
        pending++;
        now = Date.now();
        var postdata = {
                action:     'snb_get_token',
                eventstr:   eventstr + now,
                verify:     window.snbvars.verify
            };
        // console.log( postdata );
        $.ajax( {
            url:        window.snbvars.ajaxurl,
            type:       'post',
            dataType:   'text',
            data:       postdata
            
        } ).done( function( response ){
            // console.log( 'response: ' + response );
            if ( pending && response ){
                if ( !appended ){
                    $( '.wpcf7-form, .snb-form form, form.snb-form' ).each( function( ndx, el ){
                        $( el ).append( '<input type="hidden" name="snb-token" />' ); 
                        forms++;
                    } );
                    appended++;
                }
                if ( forms ){
                    eventHash = generateSha1( eventstr + now + response );
                    $( '.wpcf7-form input[name="snb-token"], .snb-form input[name="snb-token"]' ).val( response + ':' + eventHash ); //hashevent );
                    setTimeout( function(){
                        getToken();
                        startTime = 0;
                        endTime = 0;
                        timeSet = 0;
                    }, 1800000 ); // refresh token after 30 minutes
                }
                $( '.wpcf7-form input[type="submit"], .snb-form input[type="submit"]' ).prop( 'disabled', false );
                pending = 0;
            }
        } ).fail( function(){
            pending = 0;
            // console.log( 'ajax failed.' );
        } );
    }
    
    /**
     * initialize vars
     */
    var forms       = 0,    // are there contact forms on page?
        interacted  = 0,    // has input event string reached min length?
        appended    = 0,    // has verification input field been injected?
        pending     = 0,    // is XHR awaiting response?
        startTime   = 0,
        endTime     = 0,
        timeSet     = 0,
        now,
        eventCount  = 0,
        eventHash   = '',
        eventstr    = '';   // input event string
    
    
    $( document ).ready( function(){
        init(); // wait until all forms are loaded
    });
    
})(jQuery);